#ifndef __AutoConfigurationFile_h__
#define __AutoConfigurationFile_h__

#include "IConfigurationFile.h"
#include "T/ConfigurationFileFactory.h"

class AutoConfigurationFile
{
public:
	AutoConfigurationFile( const String &path )
	{
		_configurationFile = T::createConfigurationFile( path );
	}

	~AutoConfigurationFile()
	{
		T::discardConfigurationFile( _configurationFile );
		_configurationFile = 0;
	}

	operator IConfigurationFile &()
	{
		return *_configurationFile;
	}

	IConfigurationFile *operator->()
	{
		return _configurationFile;
	}

private:
	IConfigurationFile *_configurationFile;
};

#endif // __AutoConfigurationFile_h__

//
// Local Variables:
// compile-command: "make -C .. "
// tags-file-name: "../TAGS"
// c-basic-offset: 4
// End:
//
