#ifndef __T__ConfigurationFileFactory_h__
#define __T__ConfigurationFileFactory_h__

#include "cxxtest/Mock.h"

class IConfigurationFile;
class String;

namespace T
{
	IConfigurationFile *createConfigurationFile( const String &path );
	void discardConfigurationFile( IConfigurationFile *configurationFile );
}

// IConfigurationFile *createConfigurationFile( int descriptor );
// void discardConfigurationFile( IConfigurationFile *configurationFile );

CXXTEST_SUPPLY( createConfigurationFile,        /* => T::Base_AllocateIrp */
				IConfigurationFile *,           /* Return type            */
				createConfigurationFile,        /* Name of mock member    */
				( const String &path ),  /* Prototype              */
				T::createConfigurationFile,        /* Name of real function  */
				( path )       /* Parameter list         */ );

CXXTEST_SUPPLY_VOID( discardConfigurationFile,        /* => T::Base_AllocateIrp */
					 discardConfigurationFile,        /* Name of mock member    */
					 ( IConfigurationFile *configurationFile ),  /* Prototype              */
					 T::discardConfigurationFile,        /* Name of real function  */
					 ( configurationFile )            /* Parameter list         */ );

#endif // __T__ConfigurationFileFactory_h__

//
// Local Variables:
// compile-command: "make -C ../.. "
// tags-file-name: "../../TAGS"
// c-basic-offset: 4
// End:
//
