#ifndef __MockConfigurationFile_h__
#define __MockConfigurationFile_h__

#include "IConfigurationFile.h"
#include "Map.h"
#include "String.h"

class MockConfigurationFile : public IConfigurationFile
{
public:
	MockConfigurationFile()
	{
        wasCreated = false;
		wasDiscarded = false;

	}

	bool wasCreated;
	bool wasDiscarded;

    String lastPath;

	void mockConstructor( const String &path )
	{
		TS_ASSERT( !wasCreated );
		wasCreated = true;

        lastPath = path;
	}

	void mockDestructor()
	{
		TS_ASSERT( wasCreated );
		TS_ASSERT( !wasDiscarded );
		wasDiscarded = true;
	}

    Map<String, String> keysToValues;

    String getValue( const String &key )
    {
        if ( !keysToValues.exists( key ) )
        {
            throw Error( Error::VALUE_DOESNT_EXIST_IN_CONFIG_FILE, key );
        }

        return keysToValues[key];
    }
};

#endif // __MockConfigurationFile_h__

//
// Local Variables:
// compile-command: "make -C ../.. "
// tags-file-name: "../../TAGS"
// c-basic-offset: 4
// End:
//
