#ifndef __MockConfigurationFileFactory_h__
#define __MockConfigurationFileFactory_h__

#include "MockConfigurationFile.h"
#include "T/ConfigurationFileFactory.h"

class MockConfigurationFileFactory :
	public T::Base_createConfigurationFile,
	public T::Base_discardConfigurationFile
{
public:
	MockConfigurationFile mockConfigurationFile;

	~MockConfigurationFileFactory()
	{
		if ( mockConfigurationFile.wasCreated )
		{
			TS_ASSERT( mockConfigurationFile.wasDiscarded );
		}
	}

	IConfigurationFile *createConfigurationFile( const String &path )
	{
		mockConfigurationFile.mockConstructor( path );
		return &mockConfigurationFile;
	}

	void discardConfigurationFile( IConfigurationFile *configurationFile )
	{
		TS_ASSERT_EQUALS( configurationFile, &mockConfigurationFile );
		mockConfigurationFile.mockDestructor();
	}
};

#endif // __MockConfigurationFileFactory_h__

//
// Local Variables:
// compile-command: "make -C ../.. "
// tags-file-name: "../../TAGS"
// c-basic-offset: 4
// End:
//
