#ifndef __AutoCoreCommunicator_h__
#define __AutoCoreCommunicator_h__

#include "ICoreCommunicator.h"
#include "T/CoreCommunicatorFactory.h"

class AutoCoreCommunicator
{
public:
	AutoCoreCommunicator( ISelector &selector, IWeaver &weaver )
	{
		_coreCommunicator = T::createCoreCommunicator( selector, weaver );
	}

	~AutoCoreCommunicator()
	{
		T::discardCoreCommunicator( _coreCommunicator );
		_coreCommunicator = 0;
	}

	operator ICoreCommunicator &()
	{
		return *_coreCommunicator;
	}

	ICoreCommunicator *operator->()
	{
		return _coreCommunicator;
	}

private:
	ICoreCommunicator *_coreCommunicator;
};

#endif // __AutoCoreCommunicator_h__

//
// Local Variables:
// compile-command: "make -C .. "
// tags-file-name: "../TAGS"
// c-basic-offset: 4
// End:
//
