#ifndef __IWeaver_h__
#define __IWeaver_h__

class CoreMessage;
class Event;
class IThreadListener;
class String;
class ThreadStateGraph;

#include "IServerSocket.h"
#include "Vector.h"

class IWeaver : public IServerSocket::ISocketAccepter
{
public:
    virtual void bSync( IThreadListener *thread,
                        const Vector<Event> &requested,
                        const Vector<Event> &watched,
                        const Vector<Event> &blocked,
                        const String &label,
                        unsigned long long synchronizationIndex ) = 0;
    virtual void addLocalStateGraph( const String &threadName, ThreadStateGraph &threadStateGraph ) = 0;
    virtual void addForeignStateGraph( const String &threadName, ThreadStateGraph &threadStateGraph ) = 0;
    virtual void incomingCoreMessage( CoreMessage &coreMessage ) = 0;
    virtual ~IWeaver() {}
};

#endif // __IWeaver_h__

//
// Local Variables:
// compile-command: "make -C .. "
// tags-file-name: "../TAGS"
// c-basic-offset: 4
// End:
//
