#ifndef __Parameters_h__
#define __Parameters_h__

#include "AutoConfigurationFile.h"
#include "Map.h"

class Parameters
{
public:
    enum ParameterTypes {
        MANAGEMENT_PORT,
        CORE_NUMBER,
        CORE_COMMUNICATION_PORT,
    };

    static void loadParameters( const String &path )
    {
        AutoConfigurationFile configurationFile( path );

        _parameters[MANAGEMENT_PORT] = configurationFile->getValue( "bthread_management_port" );
        _parameters[CORE_NUMBER] = configurationFile->getValue( "core_number" );
        _parameters[CORE_COMMUNICATION_PORT] = configurationFile->getValue( "core_communication_port" );
    }

    static unsigned bThreadManagementPort()
    {
        return atoi( _parameters[MANAGEMENT_PORT].ascii() );
    }

    static unsigned coreNumber()
    {
        return atoi( _parameters[CORE_NUMBER].ascii() );
    }

    static unsigned coreCommunicationPort()
    {
        return atoi( _parameters[CORE_COMMUNICATION_PORT].ascii() );
    }

private:
    static Map<ParameterTypes, String> _parameters;
};

#endif // __Parameters_h__

//
// Local Variables:
// compile-command: "make -C .. "
// tags-file-name: "../TAGS"
// c-basic-offset: 4
// End:
//
