#ifndef __T__CoreCommunicatorFactory_h__
#define __T__CoreCommunicatorFactory_h__

#include "cxxtest/Mock.h"

class ICoreCommunicator;
class ISelector;
class IWeaver;

namespace T
{
	ICoreCommunicator *createCoreCommunicator( ISelector &selector, IWeaver &weaver );
	void discardCoreCommunicator( ICoreCommunicator *coreCommunicator );
}

CXXTEST_SUPPLY( createCoreCommunicator,
				ICoreCommunicator *,
				createCoreCommunicator,
				( ISelector &selector, IWeaver &weaver ),
				T::createCoreCommunicator,
				( selector, weaver ) );

CXXTEST_SUPPLY_VOID( discardCoreCommunicator,
					 discardCoreCommunicator,
					 ( ICoreCommunicator *coreCommunicator ),
					 T::discardCoreCommunicator,
					 ( coreCommunicator ) );

#endif // __T__CoreCommunicatorFactory_h__

//
// Local Variables:
// compile-command: "make -C ../.. "
// tags-file-name: "../../TAGS"
// c-basic-offset: 4
// End:
//
