#ifndef __T__ParametersFactory_h__
#define __T__ParametersFactory_h__

#include "cxxtest/Mock.h"

class String;

namespace T
{
    void loadParameters( const String &path );
    unsigned bThreadManagementPort();
    unsigned coreNumber();
    unsigned coreCommunicationPort();
}

CXXTEST_SUPPLY_VOID( loadParameters,
					 loadParameters,
					 ( const String &path ),
					 T::loadParameters,
					 ( path ) );

CXXTEST_SUPPLY( bThreadManagementPort,        /* => T::Base_AllocateIrp */
				unsigned,           /* Return type            */
				bThreadManagementPort,        /* Name of mock member    */
				(),  /* Prototype              */
				T::bThreadManagementPort,        /* Name of real function  */
				()       /* Parameter list         */ );

CXXTEST_SUPPLY( coreNumber,
				unsigned,
				coreNumber,
				(),
				T::coreNumber,
				() );

CXXTEST_SUPPLY( coreCommunicationPort,
				unsigned,
				coreCommunicationPort,
				(),
				T::coreCommunicationPort,
				() );

#endif // __T__ParametersFactory_h__

//
// Local Variables:
// compile-command: "make -C ../.. "
// tags-file-name: "../../TAGS"
// c-basic-offset: 4
// End:
//
