#ifndef __MockCoreCommunicator_h__
#define __MockCoreCommunicator_h__

#include "CoreMessage.h"
#include "Event.h"
#include "ISelector.h"
#include "ICoreCommunicator.h"
#include "Vector.h"

class MockCoreCommunicator : public ICoreCommunicator
{
public:
	MockCoreCommunicator()
	{
		wasCreated = false;
		wasDiscarded = false;
	}

	bool wasCreated;
	bool wasDiscarded;

    ISelector *lastSelector;
    IWeaver *lastWeaver;

	void mockConstructor( ISelector &selector, IWeaver &weaver )
	{
		TS_ASSERT( !wasCreated );
		wasCreated = true;

        lastSelector = &selector;
        lastWeaver = &weaver;
	}

	void mockDestructor()
	{
		TS_ASSERT( wasCreated );
		TS_ASSERT( !wasDiscarded );
		wasDiscarded = true;
	}

	void handleAcceptedSocket( ISocket & )
	{
	}

    int descriptor()
    {
        return 0;
    }

    void canRead()
    {
    }

    String lastSentLabel;
    String lastSentName;
    unsigned long long lastSentMessageIndex;

    void send( CoreMessage &coreMessage )
    {
        lastSentLabel = coreMessage.chosenLabel();
        lastSentName = coreMessage.threadName();
        lastSentMessageIndex = coreMessage.synchronizationIndex();
    }
};

#endif // __MockCoreCommunicator_h__

//
// Local Variables:
// compile-command: "make -C ../.. "
// tags-file-name: "../../TAGS"
// c-basic-offset: 4
// End:
//
