#ifndef __MockCoreCommunicatorFactory_h__
#define __MockCoreCommunicatorFactory_h__

#include "MockCoreCommunicator.h"
#include "T/CoreCommunicatorFactory.h"

class MockCoreCommunicatorFactory :
	public T::Base_createCoreCommunicator,
	public T::Base_discardCoreCommunicator
{
public:
	MockCoreCommunicator mockCoreCommunicator;

	~MockCoreCommunicatorFactory()
	{
		if ( mockCoreCommunicator.wasCreated )
		{
			TS_ASSERT( mockCoreCommunicator.wasDiscarded );
		}
	}

	ICoreCommunicator *createCoreCommunicator( ISelector &selector, IWeaver &weaver )
	{
		mockCoreCommunicator.mockConstructor( selector, weaver );
		return &mockCoreCommunicator;
	}

	void discardCoreCommunicator( ICoreCommunicator *coreCommunicator )
	{
		TS_ASSERT_EQUALS( coreCommunicator, &mockCoreCommunicator );
		mockCoreCommunicator.mockDestructor();
	}
};

#endif // __MockCoreCommunicatorFactory_h__

//
// Local Variables:
// compile-command: "make -C ../.. "
// tags-file-name: "../../TAGS"
// c-basic-offset: 4
// End:
//
