#ifndef __MockParameters_h__
#define __MockParameters_h__

#include "String.h"
#include "T/ParametersFactory.h"
#include "TestLog.h"

class MockParameters :
    public T::Base_loadParameters,
    public T::Base_bThreadManagementPort,
    public T::Base_coreNumber,
    public T::Base_coreCommunicationPort
{
public:
    String lastLoadedPath;

    void loadParameters( const String &path )
    {
        TestLog::log( "Parameters loaded" );
        lastLoadedPath = path;
    }

    unsigned nextBThreadManagementPort;

    unsigned bThreadManagementPort()
    {
        return nextBThreadManagementPort;
    }

    unsigned nextCoreNumber;

    unsigned coreNumber()
    {
        return nextCoreNumber;
    }

    unsigned nextCoreCommunicationPort;

    unsigned coreCommunicationPort()
    {
        return nextCoreCommunicationPort;
    }
};

#endif // __MockParameters_h__

//
// Local Variables:
// compile-command: "make -C .. "
// tags-file-name: "../TAGS"
// c-basic-offset: 4
// End:
//
