#include <cxxtest/TestSuite.h>

#include "Event.h"
#include "EventSelector.h"
#include "MockErrno.h"
#include "RealMalloc.h"

class MockForEventSelector :
    public MockErrno,
    public RealMalloc
{
public:
};

class EventSelectorTestSuite : public CxxTest::TestSuite
{
public:
	MockForEventSelector *mock;

	void setUp()
	{
		TS_ASSERT( mock = new MockForEventSelector );
    }

	void tearDown()
	{
        TS_ASSERT_THROWS_NOTHING( delete mock );
	}

    void test_select()
    {
        return;

        Vector<Event> requested;
        Vector<Event> blocked;

        requested.append( 1 );
        TS_ASSERT_EQUALS( EventSelector::select( requested, blocked ).type(), 1U );

        requested.append( 2 );
        TS_ASSERT_EQUALS( EventSelector::select( requested, blocked ).type(), 1U );

        blocked.append( 1 );
        TS_ASSERT_EQUALS( EventSelector::select( requested, blocked ).type(), 2U );

        blocked.append( 2 );
        TS_ASSERT_THROWS_EQUALS( EventSelector::select( requested, blocked ).type(),
                                 const Error &e,
                                 e.code(),
                                 Error::SELECTION_DEADLOCKED );

        requested.append( 4 );
        TS_ASSERT_EQUALS( EventSelector::select( requested, blocked ).type(), 4U );

        requested.append( 3 );
        TS_ASSERT_EQUALS( EventSelector::select( requested, blocked ).type(), 3U );
    }
};

//
// Local Variables:
// compile-command: "make -C ../.. "
// tags-file-name: "../../TAGS"
// c-basic-offset: 4
// End:
//
