#ifndef __Car1_h__
#define __Car1_h__

#include "BThread.h"
#include "IEvent.h"
#include "Point.h"
#include "String.h"
#include "T/Truth.h"
#include "T/unistd.h"

class Car1 : public BThread
{
public:
    Car1() : BThread( "Car1" )
    {
    }

    void entryPoint()
    {
        while ( T::alwaysTrue() )
        {
            requestZero();

            if ( flipCoin() )
            {
                goToB();
            }

            T::sleep( 1 );
        }
    }

private:
    Vector<Event> _requested;
    Vector<Event> _watched;
    Vector<Event> _blocked;

    void clearAll()
    {
        _requested.clear();
        _watched.clear();
        _blocked.clear();
    }

    void requestZero()
    {
        clearAll();
        _requested.append( IEvent::ZERO );
        bSync( _requested, _watched, _blocked, "A" );
    }

    bool flipCoin()
    {
        return T::rand() % 2;
    }

    void goToB()
    {
        clearAll();
        _watched.append( IEvent::ZERO );
        _watched.append( IEvent::ONE );

        bSync( _requested, _watched, _blocked, "B" );

        while ( !lastEvent().type() == IEvent::ONE )
        {
            bSync( _requested, _watched, _blocked, "B" );

            T::sleep( 3 );
        }
    }
};

#endif // __Car1_h__

//
// Local Variables:
// compile-command: "make -C .. "
// tags-file-name: "../TAGS"
// c-basic-offset: 4
// End:
//
