#ifndef __Car1Spanner_h__
#define __Car1Spanner_h__

#include "Car1.h"
#include "ProbabilisticStateGraphSpanner.h"

class Car1Token : public ProbabilisticStateGraphSpanner::ThreadToken
{
public:
    BThread *freshCopy()
    {
        return new Car1;
    }

    class EnvironmentOne :
        public ProbabilisticStateGraphSpanner::EnvironmentConfiguration,
        public T::Base_rand,
        public T::Base_sleep
    {
    public:
        int rand()
        {
            return 1;
        }

        unsigned int sleep( unsigned int )
        {
            return 0;
        }
    };

    class EnvironmentTwo :
        public ProbabilisticStateGraphSpanner::EnvironmentConfiguration,
        public T::Base_rand,
        public T::Base_sleep
    {
    public:
        int rand()
        {
            return 0;
        }

        unsigned int sleep( unsigned int )
        {
            return 0;
        }
    };

    unsigned numberOfEnvironments()
    {
        return 2;
    }

    ProbabilisticStateGraphSpanner::EnvironmentConfiguration *freshEnvironment( unsigned index )
    {
        switch ( index )
        {
        case 0:
            return new EnvironmentOne;
            break;
        case 1:
            return new EnvironmentTwo;
            break;
        default:
            TS_FAIL( "Error" );
            break;
        }

        return NULL;
    }
};

class Car1Spanner
{
public:
    void span( ThreadStateGraph &stateGraph )
    {
        Car1Token token;
        ProbabilisticStateGraphSpanner().span( token, stateGraph );
    }
};

#endif // __Car1Spanner_h__

//
// Local Variables:
// compile-command: "make -C ../.. "
// tags-file-name: "../../TAGS"
// c-basic-offset: 4
// End:
//
