#include <cxxtest/TestSuite.h>

#include "Car1Spanner.h"
#include "Event.h"
#include "IEvent.h"
#include "MockErrno.h"
#include "MockParameters.h"
#include "RealMalloc.h"
#include "Vector.h"

const char *XML_DIRECTORY = "/home/guy/projects/elevator/xml";

class MockForProperties :
    public RealMalloc,
    public MockErrno,
    public MockParameters
{
public:
};

class PropertiesTestSuite : public CxxTest::TestSuite
{
public:
    MockForProperties *mock;
    ThreadStateGraph _car1;

    PropertiesTestSuite()
    {
        Vector<Event> events;

        events.append( Event( IEvent::ZERO ) );
        events.append( Event( IEvent::ONE ) );

        _car1._events = events;
    }

    void setUp()
    {
        TS_ASSERT( mock = new MockForProperties );
    }

    void tearDown()
    {
        TS_ASSERT_THROWS_NOTHING( delete mock );
    }

    void test_program_properties()
    {
        TS_TRACE( "\tSpanning thread graph" );

        Car1Spanner().span( _car1 );

        _car1.dump();
    }
};

//
// Local Variables:
// compile-command: "make -C ../.. "
// tags-file-name: "../../TAGS"
// c-basic-offset: 4
// End:
//
