#ifndef __Car2_h__
#define __Car2_h__

#include "BThread.h"
#include "IEvent.h"
#include "Point.h"
#include "String.h"
#include "T/Truth.h"
#include "T/unistd.h"

class Car2 : public BThread
{
public:
    Car2() : BThread( "Car2" )
    {
    }

    void entryPoint()
    {
        while ( T::alwaysTrue() )
        {
            requestZero();

            if ( flipCoin() )
            {
                requestAnotherZero();
            }
            else
            {
                requestOne();
            }

            T::sleep( 2 );
        }
    }

private:
    Vector<Event> _requested;
    Vector<Event> _watched;
    Vector<Event> _blocked;

    void clearAll()
    {
        _requested.clear();
        _watched.clear();
        _blocked.clear();
    }

    void requestZero()
    {
        clearAll();
        _requested.append( IEvent::ZERO );
        bSync( _requested, _watched, _blocked, "C" );
    }

    void requestAnotherZero()
    {
        clearAll();
        _requested.append( IEvent::ZERO );
        bSync( _requested, _watched, _blocked, "D" );
    }

    void requestOne()
    {
        clearAll();
        _requested.append( IEvent::ONE );
        bSync( _requested, _watched, _blocked, "E" );
    }

    bool flipCoin()
    {
        return T::rand() % 2;
    }
};

#endif // __Car2_h__

//
// Local Variables:
// compile-command: "make -C .. "
// tags-file-name: "../TAGS"
// c-basic-offset: 4
// End:
//
